# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xscspfserver`](#dsc_xscspfserver): The DSC xSCSPFServer resource type. Automatically generated from version 1.3.1.0
* [`dsc_xscspfserversetup`](#dsc_xscspfserversetup): The DSC xSCSPFServerSetup resource type. Automatically generated from version 1.3.1.0
* [`dsc_xscspfserverupdate`](#dsc_xscspfserverupdate): The DSC xSCSPFServerUpdate resource type. Automatically generated from version 1.3.1.0
* [`dsc_xscspfsetting`](#dsc_xscspfsetting): The DSC xSCSPFSetting resource type. Automatically generated from version 1.3.1.0
* [`dsc_xscspfstamp`](#dsc_xscspfstamp): The DSC xSCSPFStamp resource type. Automatically generated from version 1.3.1.0

## Resource types

### `dsc_xscspfserver`

The DSC xSCSPFServer resource type.
Automatically generated from version 1.3.1.0

#### Properties

The following properties are available in the `dsc_xscspfserver` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

An enumerated value that describes if the SPF server exists. Present {default}   Absent    

##### `dsc_servertype`

Data type: `Enum['VMM', 'OM', 'DPM', 'OMDW', 'RDGateway', 'Orchestrator', 'None']`

Specifies the type of server.

#### Parameters

The following parameters are available in the `dsc_xscspfserver` type.

##### `dsc_name`

namevar

Data type: `String`

Specifies a name for the server.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_scspfadmincredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential with admin permissions to Service Provider Foundation.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xscspfserversetup`

The DSC xSCSPFServerSetup resource type.
Automatically generated from version 1.3.1.0

#### Properties

The following properties are available in the `dsc_xscspfserversetup` type.

##### `dsc_adminsecuritygroupusers`

Data type: `Optional[String]`

Administrator of the Admin application pool

##### `dsc_certificatename`

Data type: `Optional[String]`

Name of existing certificate to use.

##### `dsc_databasename`

Data type: `Optional[String]`

Name of the SPF database.

##### `dsc_databaseportnumber`

Data type: `Optional[Integer[0, 65535]]`

Port of the database server instance.

##### `dsc_databaseserver`

Data type: `String`

Name of the database server.

##### `dsc_providersecuritygroupusers`

Data type: `Optional[String]`

Administrator of the Provider application pool

##### `dsc_scadminusername`

Data type: `Optional[String]`

Output username of the Admin application pool serivce.

##### `dsc_scproviderusername`

Data type: `Optional[String]`

Output username of the Provider application pool serivce.

##### `dsc_scusageusername`

Data type: `Optional[String]`

Output username of the Usage application pool serivce.

##### `dsc_scvmmusername`

Data type: `Optional[String]`

Output username of the VMM application pool serivce.

##### `dsc_sendceipreports`

Data type: `Optional[String]`

Participate in the Customer Experience Improvement Program.

##### `dsc_sourcefolder`

Data type: `Optional[String]`

Folder within the source path containing the source files for installation.

##### `dsc_sourcepath`

Data type: `String`

UNC path to the root of the source files for installation.

##### `dsc_specifycertificate`

Data type: `Optional[Boolean]`

Use an existing certificate.

##### `dsc_usagesecuritygroupusers`

Data type: `Optional[String]`

Administrator of the Usage application pool

##### `dsc_usemicrosoftupdate`

Data type: `Optional[String]`

Use Microsoft Update.

##### `dsc_vmmsecuritygroupusers`

Data type: `Optional[String]`

Administrator of the VMM application pool.

##### `dsc_websiteportnumber`

Data type: `Optional[Integer[0, 65535]]`

Port for the SPF web service.

#### Parameters

The following parameters are available in the `dsc_xscspfserversetup` type.

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

An enumerated value that describes if SPF server is expected to be installed on the machine. Present {default}   Absent

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_scadmin`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential for the Admin application pool

##### `dsc_scprovider`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential for the Provider application pool

##### `dsc_scusage`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential for the Usage application pool

##### `dsc_scvmm`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential for the VMM application pool.

##### `dsc_setupcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xscspfserverupdate`

The DSC xSCSPFServerUpdate resource type.
Automatically generated from version 1.3.1.0

#### Properties

The following properties are available in the `dsc_xscspfserverupdate` type.

##### `dsc_sourcefolder`

Data type: `Optional[String]`

Folder within the source path containing the source files for installation.

##### `dsc_sourcepath`

Data type: `String`

UNC path to the root of the source files for installation.

##### `dsc_update`

Data type: `Optional[String]`

Display name of the update.

#### Parameters

The following parameters are available in the `dsc_xscspfserverupdate` type.

##### `dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

An enumerated value that describes if the update is expected to be installed on the machine. Present {default}   Absent

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_setupcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xscspfsetting`

The DSC xSCSPFSetting resource type.
Automatically generated from version 1.3.1.0

#### Properties

The following properties are available in the `dsc_xscspfsetting` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

An enumerated value that describes if the SPF setting exists. Present {default}   Absent    

##### `dsc_settingtype`

Data type: `Enum['DatabaseConnectionString', 'EndPointConnectionString']`

Specifies either DatabaseConnectionString or EndPointConnectionString.

##### `dsc_value`

Data type: `String`

Specifies the value for the setting.

#### Parameters

The following parameters are available in the `dsc_xscspfsetting` type.

##### `dsc_name`

namevar

Data type: `String`

Specifies a friendly name for the setting.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_scspfadmincredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential with admin permissions to Service Provider Foundation.

##### `dsc_servername`

namevar

Data type: `String`

Specifies the name of the server the setting is associated with.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xscspfstamp`

The DSC xSCSPFStamp resource type.
Automatically generated from version 1.3.1.0

#### Properties

The following properties are available in the `dsc_xscspfstamp` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

An enumerated value that describes if the SPF stamp exists. Present {default}   Absent    

##### `dsc_servers`

Data type: `Array[String]`

Specifies the name of one or more server objects to associate with the new stamp.

#### Parameters

The following parameters are available in the `dsc_xscspfstamp` type.

##### `dsc_name`

namevar

Data type: `String`

Specifies a name for the stamp.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_scspfadmincredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential with admin permissions to Service Provider Foundation.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

