require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xscspfserver',
  dscmeta_resource_friendly_name: 'xSCSPFServer',
  dscmeta_resource_name: 'MSFT_xSCSPFServer',
  dscmeta_module_name: 'xSCSPF',
  dscmeta_module_version: '1.3.1.0',
  docs: 'The DSC xSCSPFServer resource type.
         Automatically generated from version 1.3.1.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_scspfadmincredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: 'Credential with admin permissions to Service Provider Foundation.',
      behaviour: :parameter,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_name: {
      type: 'String',
      desc: 'Specifies a name for the server.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_servertype: {
      type: "Enum['VMM', 'OM', 'DPM', 'OMDW', 'RDGateway', 'Orchestrator', 'None']",
      desc: 'Specifies the type of server.',

      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: 'An enumerated value that describes if the SPF server exists. Present {default}   Absent    ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
